/*
 * Blockdaemon REST API
 *
 * Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// EvmFee The priority fee.
type EvmFee struct {
	// The fast slow priority fee.
	MaxPriorityFee *bigInt `json:"max_priority_fee,omitempty"`
	// The fast slow total fee.
	MaxTotalFee *bigInt `json:"max_total_fee,omitempty"`
}

// NewEvmFee instantiates a new EvmFee object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewEvmFee() *EvmFee {
	this := EvmFee{}
	return &this
}

// NewEvmFeeWithDefaults instantiates a new EvmFee object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewEvmFeeWithDefaults() *EvmFee {
	this := EvmFee{}
	return &this
}

// GetMaxPriorityFee returns the MaxPriorityFee field value if set, zero value otherwise.
func (o *EvmFee) GetMaxPriorityFee() bigInt {
	if o == nil || o.MaxPriorityFee == nil {
		var ret bigInt
		return ret
	}
	return *o.MaxPriorityFee
}

// GetMaxPriorityFeeOk returns a tuple with the MaxPriorityFee field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EvmFee) GetMaxPriorityFeeOk() (*bigInt, bool) {
	if o == nil || o.MaxPriorityFee == nil {
		return nil, false
	}
	return o.MaxPriorityFee, true
}

// HasMaxPriorityFee returns a boolean if a field has been set.
func (o *EvmFee) HasMaxPriorityFee() bool {
	if o != nil && o.MaxPriorityFee != nil {
		return true
	}

	return false
}

// SetMaxPriorityFee gets a reference to the given bigInt and assigns it to the MaxPriorityFee field.
func (o *EvmFee) SetMaxPriorityFee(v bigInt) {
	o.MaxPriorityFee = &v
}

// GetMaxTotalFee returns the MaxTotalFee field value if set, zero value otherwise.
func (o *EvmFee) GetMaxTotalFee() bigInt {
	if o == nil || o.MaxTotalFee == nil {
		var ret bigInt
		return ret
	}
	return *o.MaxTotalFee
}

// GetMaxTotalFeeOk returns a tuple with the MaxTotalFee field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EvmFee) GetMaxTotalFeeOk() (*bigInt, bool) {
	if o == nil || o.MaxTotalFee == nil {
		return nil, false
	}
	return o.MaxTotalFee, true
}

// HasMaxTotalFee returns a boolean if a field has been set.
func (o *EvmFee) HasMaxTotalFee() bool {
	if o != nil && o.MaxTotalFee != nil {
		return true
	}

	return false
}

// SetMaxTotalFee gets a reference to the given bigInt and assigns it to the MaxTotalFee field.
func (o *EvmFee) SetMaxTotalFee(v bigInt) {
	o.MaxTotalFee = &v
}

func (o EvmFee) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.MaxPriorityFee != nil {
		toSerialize["max_priority_fee"] = o.MaxPriorityFee
	}
	if o.MaxTotalFee != nil {
		toSerialize["max_total_fee"] = o.MaxTotalFee
	}
	return json.Marshal(toSerialize)
}

type NullableEvmFee struct {
	value *EvmFee
	isSet bool
}

func (v NullableEvmFee) Get() *EvmFee {
	return v.value
}

func (v *NullableEvmFee) Set(val *EvmFee) {
	v.value = val
	v.isSet = true
}

func (v NullableEvmFee) IsSet() bool {
	return v.isSet
}

func (v *NullableEvmFee) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableEvmFee(val *EvmFee) *NullableEvmFee {
	return &NullableEvmFee{value: val, isSet: true}
}

func (v NullableEvmFee) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableEvmFee) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
